<%@ Page language="c#" AutoEventWireup="true" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<script language="C#" runat="server">
//--------------------------------------------------------------------------
// Title        : IP Address to Country & ISP Lookup Service using Database
// Description  : This script lookup the country & ISP from an IP address.
//                Things that we can do with this script.
//                		1. Display native language and currency 
//                		2. Redirect based on country 
//                		3. Digital rights management 
//                		4. Prevent password sharing and abuse of service 
//                		5. Reduce credit card fraud 
//                		6. Web log stats and analysis 
//                		7. Auto-selection of country on forms 
//                		8. Filter access from countries you do not do business with 
//                		9. Geo-targeting for increased sales and click-thrus 
//                		10. And much, much more! 
//
// Author       : IP2Location.com
// URL          : http://www.ip2location.com
// Email        : sales@ip2location.com
//
// Copyright (c) 2002-2015 IP2Location.com
//---------------------------------------------------------------------------
		void Page_Load(object sender, System.EventArgs e)
		{
			string ipaddress;
			long ipno;
			string [] arripaddress;
			int i;
			
			Response.Write("<HTML>\n");
			Response.Write("	<HEAD>\n");
			Response.Write("		<TITLE>IP2Location IP-COUNTRY-ISP Database Demo in Active Server Pages.NET (ASP.NET) </TITLE>\n");
			Response.Write("		<STYLE> TABLE,BODY,P{ color:Black; font-family:Verdana,Geneva,Arial,Helvetica,sans-serif; font-size:12px; }\n");
			Response.Write("			H1{ color:Black; font-family:Verdana,Geneva,Arial,Helvetica,sans-serif; font-size:16px; }\n");
			Response.Write("			A.blue,A.blue:VISITED,A.blue:LINK{ text-decoration:none;font-weight:bolder; color:Blue; }\n");
			Response.Write("		</STYLE>\n");
			Response.Write("	</HEAD>\n");
			Response.Write("	<BODY bgColor=\"#ffffff\">\n");
			Response.Write("		<form action=\"" + Request["SCRIPT_NAME"] + "\" method=\"POST\">\n");
			Response.Write("		<center>\n");
			Response.Write("		<H1><B><U>IP2Location&#153; Demo - Lookup Country & ISP by IP Address</U></H1>\n");
			Response.Write("		<P></B>Enter a dotted IP address (0.0.0.0 to 1.255.255.255).<BR>\n");
			Response.Write("		<textarea name=\"ipaddress\" cols=15 rows=6></textarea><br>\n");
			Response.Write("		<input type=\"submit\" name=\"submit\" value=\"submit\">\n");

			if (Request.Form.Count > 0) 
			{
				// get the IP address from the form
				ipaddress = Request.Form["ipaddress"];
				ipaddress = ipaddress.Replace("\r\n", ",");
				ipaddress = ipaddress.Replace(" ", ",");
				arripaddress = ipaddress.Split(',');
				if (arripaddress.Length != 0)
				{
					Response.Write("<p>");
					Response.Write("<h1><u>IP2Location&#153; Lookup Results</u></h1>");
					Response.Write("<table border = 1>");
					// display header
					Response.Write("<tr>");
					Response.Write("<td align=center>IP Address</td>");
					Response.Write("<td align=center>Country Code</td>");
					Response.Write("<td align=center>Country Name</td>");
					Response.Write("<td align=center>ISP</td>");
					Response.Write("</tr>");
					for (i = 0 ; i <= arripaddress.Length - 1; i++)
					{
						if (arripaddress[i] != "")
						{
							// check if the IP address is supported in demo version
							ipno = IP2Decimal(arripaddress[i]);
							if ((ipno < 0) || (ipno > 33554431))
							{
								Response.Write("<tr>");
								Response.Write("<td align=center>IP address " + arripaddress[i] + " is not supported in demo version.</td>");
								Response.Write("<td align=center>-</td>");
								Response.Write("<td align=center>-</td>");
								Response.Write("<td align=center>-</td>");
								Response.Write("</tr>");
							}
							else
							{
								SqlDataReader reader;
								// select MS-SQL database using DSNless connection
								SqlConnection sqlConn = new SqlConnection("Server=127.0.0.1;Database=ip2location;User Id=sa;Password=12345;");
								// query string to lookup the country & ISP by matching the range of IP address number
								SqlCommand sqlCmd = new SqlCommand("SELECT TOP 1 country_code, country_name, isp FROM ip2location_db2 WHERE " + ipno.ToString() + " <= ip_to ORDER BY ip_to", sqlConn);
								sqlCmd.Connection.Open();
								// execute the query
								reader = sqlCmd.ExecuteReader(System.Data.CommandBehavior.CloseConnection);
								// display results
								if (reader.Read())
								{
									Response.Write("<tr>");
									Response.Write("<td align=center>" + arripaddress[i] + "</td>");
									Response.Write("<td align=center>" + reader.GetString(0) + "</td>");
									Response.Write("<td align=center>" + reader.GetString(1) + "</td>");
									Response.Write("<td align=center>" + reader.GetString(2) + "</td>");
									Response.Write("</tr>");
								}
								else
								{
									Response.Write("<tr>");
									Response.Write("<td align=center>" + arripaddress[i] + "</td>");
									Response.Write("<td align=center>-</td>");
									Response.Write("<td align=center>-</td>");
									Response.Write("<td align=center>-</td>");
									Response.Write("</tr>");
								}
								sqlCmd.Connection.Close();
							}
						}
					}
					Response.Write("		</table>\n");
					Response.Write("		</p>\n");
				}
				else
				{
					Response.Write("Please enter ip address.");
				}
			}
			Response.Write("		<BR>\n");
			Response.Write("		[<A href=\"http://www.ip2location.com\">Click here to subscribe full database</A>]\n");
			Response.Write("		<BR>\n");
			Response.Write("		<BR>\n");
			Response.Write("		Copyright (c) 2002-2015 by <a href=\"http://www.ip2location.com\">IP2Location.com</a>\n");
			Response.Write("		<P>\n");
			Response.Write("			<a href=\"http://www.ip2location.com/\"><img src=\"http://www.ip2location.com/images/ip2location468x60_0.gif\" border=\"0\"></a>\n");
			Response.Write("		</P>\n");
			Response.Write("		</center>\n");
			Response.Write("		</form>\n");
			Response.Write("	</BODY>\n");
			Response.Write("</HTML>\n");
		}

		// Convert dotted IP address into IP number in long
		public long IP2Decimal(String DottedIP)
		{
			string [] arrConvert;
			int i;
			long intResult=0;
			try
			{
				arrConvert = DottedIP.Split('.');
				for (i = arrConvert.Length - 1; i >= 0; i--)
				{
					intResult = intResult + ((long.Parse(arrConvert[i]) % 256) * long.Parse(Math.Pow(256, 3 - i).ToString()));
				}
				return intResult;
			}
			catch (Exception ex)
			{
				Response.Write(ex.Message);
				return 0;
			}
		}
</script>
