<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Data" %>
<%@ Page Language="vb" AutoEventWireup="false" %>
<script language="vb" runat="server">
'---------------------------------------------------------------------------
' Title        : IP Address to Country & ISP Lookup Service using Database
' Description  : This script lookup the country & isp from an IP address.
'                Things that we can do with this script.
'                		1. Display native language and currency 
'                		2. Redirect based on country 
'                		3. Digital rights management 
'                		4. Prevent password sharing and abuse of service 
'                		5. Reduce credit card fraud 
'                		6. Web log stats and analysis 
'                		7. Auto-selection of country on forms 
'                		8. Filter access from countries you do not do business with 
'                		9. Geo-targeting for increased sales and click-thrus 
'                		10. And much, much more! 
'
' Author       : IP2Location.com
' URL          : http://www.ip2location.com
' Email        : sales@ip2location.com
'
' Copyright (c) 2002-2015 IP2Location.com
'---------------------------------------------------------------------------
    Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        Dim ipaddress As String
        Dim ipno As Long
        Dim strsql As String
        Dim arripaddress() As String
        Dim i As Integer

        Response.Write("<HTML>" & vbCrLf)
        Response.Write("	<HEAD>" & vbCrLf)
        Response.Write("		<TITLE>IP2Location IP-COUNTRY-ISP Database Demo in Active Server Pages.NET (ASP.NET) </TITLE>" & vbCrLf)
        Response.Write("		<STYLE> TABLE,BODY,P{ color:Black; font-family:Verdana,Geneva,Arial,Helvetica,sans-serif; font-size:12px; }" & vbCrLf)
        Response.Write("			H1{ color:Black; font-family:Verdana,Geneva,Arial,Helvetica,sans-serif; font-size:16px; }" & vbCrLf)
        Response.Write("			A.blue,A.blue:VISITED,A.blue:LINK{ text-decoration:none;font-weight:bolder; color:Blue; }" & vbCrLf)
        Response.Write("		</STYLE>" & vbCrLf)
        Response.Write("	</HEAD>" & vbCrLf)
        Response.Write("	<BODY bgColor=""#ffffff"">" & vbCrLf)
        Response.Write("		<form action=""" & Request("SCRIPT_NAME") & """ method=""POST"">" & vbCrLf)
        Response.Write("		<center>" & vbCrLf)
        Response.Write("		<H1><B><U>IP2Location&#153; Demo - Lookup Country & ISP by IP Address</U></H1>" & vbCrLf)
        Response.Write("		<P></B>Enter a dotted IP address (0.0.0.0 to 1.255.255.255).<BR>" & vbCrLf)
        Response.Write("		<textarea name=""ipaddress"" cols=15 rows=6></textarea><br>")
        Response.Write("		<input type=""submit"" name=""submit"" value=""submit"">" & vbCrLf)

        If Not Request.Form("ipaddress") = "" Then
            ' get the IP address from the form
            ipaddress = Request.Form("ipaddress")
            ipaddress = ipaddress.Replace(vbNewLine, ",")
            ipaddress = ipaddress.Replace(" ", ",")
            arripaddress = ipaddress.Split(",")
            If arripaddress.Length <> 0 Then
                Response.Write("<p>")
                Response.Write("<h1><u>IP2Location&#153; Lookup Results</u></h1>")
                Response.Write("<table border = 1>")
                ' display header
                Response.Write("<tr>")
                Response.Write("<td align=center>IP Address</td>")
                Response.Write("<td align=center>Country Code</td>")
                Response.Write("<td align=center>Country Name</td>")
                Response.Write("<td align=center>ISP</td>")
                Response.Write("</tr>")
                For i = 0 To arripaddress.Length - 1
                    If arripaddress(i) <> "" Then
                        ipno = IP2Decimal(arripaddress(i))
                        ' check if the IP address is supported in demo version
                        If (ipno < 0) Or (ipno > 33554431) Then
							Response.Write("<tr>")
							Response.Write("<td align=center>IP address " & arripaddress(i) & " is not supported in demo version.</td>")
							Response.Write("<td align=center>-</td>")
							Response.Write("<td align=center>-</td>")
							Response.Write("<td align=center>-</td>")
							Response.Write("</tr>")
                        Else
                            Dim reader As SqlDataReader
                            ' select MS-SQL database using DSNless connection
                            Dim sqlConn As SqlConnection  = New SqlConnection("Server=127.0.0.1;Database=ip2location;User Id=sa;Password=12345;")
							' query string to lookup the country & isp by matching the range of IP address number
							Dim sqlCmd As SqlCommand = New SqlCommand("SELECT TOP 1 country_code, country_name, isp FROM ip2location_db2 WHERE " + ipno.ToString() + " <= ip_to ORDER BY ip_to", sqlConn)
                            sqlCmd.Connection.Open()
                            ' execute the query
                            reader = sqlCmd.ExecuteReader(System.Data.CommandBehavior.CloseConnection)
                            ' display results
                            If reader.Read() Then
                                Response.Write("<tr>")
                                Response.Write("<td align=center>" & arripaddress(i) & "</td>")
                                Response.Write("<td align=center>" & reader.GetString(0) & "</td>")
                                Response.Write("<td align=center>" & reader.GetString(1) & "</td>")
                                Response.Write("<td align=center>" & reader.GetString(2) & "</td>")
                                Response.Write("</tr>")
							Else
								Response.Write("<tr>")
								Response.Write("<td align=center>" & arripaddress(i) & "</td>")
								Response.Write("<td align=center>-</td>")
								Response.Write("<td align=center>-</td>")
								Response.Write("<td align=center>-</td>")
								Response.Write("</tr>")
                            End If
                            sqlCmd.Connection.Close()
                        End If
                    End If
                Next
                Response.Write("		</table>" & vbCrLf)
                Response.Write("		</p>" & vbCrLf)
            Else
                Response.Write("Please enter ip address.")
            End If
        End If
        Response.Write("		<BR>" & vbCrLf)
        Response.Write("		[<A href=""http://www.ip2location.com"">Click here to subscribe full database</A>]" & vbCrLf)
        Response.Write("		<BR>" & vbCrLf)
        Response.Write("		<BR>" & vbCrLf)
        Response.Write("		Copyright (c) 2002-2015 by <a href=""http://www.ip2location.com"">IP2Location.com</a>" & vbCrLf)
        Response.Write("		<P>" & vbCrLf)
        Response.Write("			<a href=""http://www.ip2location.com/""><img src=""http://www.ip2location.com/images/ip2location468x60_0.gif"" border=""0""></a>" & vbCrLf)
        Response.Write("		</P>" & vbCrLf)
        Response.Write("		</center>" & vbCrLf)
        Response.Write("		</form>" & vbCrLf)
        Response.Write("	</BODY>" & vbCrLf)
        Response.Write("</HTML>" & vbCrLf)
    End Sub

    ' Convert dotted IP address into IP number in long
    Public Function IP2Decimal(ByVal DottedIP As String)
        Dim arrConvert() As String
        Dim i As Integer
        Dim intResult As Long
        Try
            arrConvert = DottedIP.Split(".")
            For i = arrConvert.Length - 1 To 0 Step -1
                intResult = intResult + ((Int(arrConvert(i)) Mod 256) * Math.Pow(256, 3 - i))
            Next
            Return intResult
        Catch ex As Exception
            Return 0
        End Try
    End Function
</script>